Package com.sas.metadata.remote

# Interface AbstractPrompt

All Superinterfaces:
  `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `PrimaryType`, `Remote`, `Root`

All Known Subinterfaces:
  `Prompt`, `PromptGroup`

public interface AbstractPrompt extends PrimaryType
The parent class for types used by the SAS Prompt Interface.

Attributes of AbstractPrompt are:

Associations of AbstractPrompt are:

- `PromptReferences`
- `ValueSource`
- `PromptEnabledObject`
- `ReferencedPrompts`

## Usage

To create an instance of this AbstractPrompt, use the `factory` create methods.
Example: create a AbstractPrompt with name "AbstractPrompt_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     AbstractPrompt myObject = (AbstractPrompt) factory.createComplexMetadataObject(objectStore, "AbstractPrompt_Object", MetadataObjects.ABSTRACTPROMPT, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_PROMPTENABLEDOBJECT_NAME`
  Constant used for the name of the PromptEnabledObject association.
  `static final String`
  `ASSOCIATION_PROMPTREFERENCES_NAME`
  Constant used for the name of the PromptReferences association.
  `static final String`
  `ASSOCIATION_REFERENCEDPROMPTS_NAME`
  Constant used for the name of the ReferencedPrompts association.
  `static final String`
  `ASSOCIATION_VALUESOURCE_NAME`
  Constant used for the name of the ValueSource association.

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Root`
  `getPromptEnabledObject()`
  Gets the `Root` for `PromptEnabledObject`
  `AssociationList`
  `getPromptEnabledObjects()`
  Gets the Association list of `PromptEnabledObjects`
  `AssociationList`
  `getPromptEnabledObjects(boolean fGoToServer)`
  Gets the Associationlist of `PromptEnabledObjects`
  `AssociationList`
  `getPromptReferences()`
  Gets the AssociationList of `PromptReferences`
  `AssociationList`
  `getPromptReferences(boolean fGoToServer)`
  Gets the Associationlist of `PromptReferences`
  `AssociationList`
  `getReferencedPrompts()`
  Gets the Association list of `ReferencedPrompts`
  `AssociationList`
  `getReferencedPrompts(boolean fGoToServer)`
  Gets the Associationlist of `ReferencedPrompts`
  `Transformation`
  `getValueSource()`
  Gets the `Transformation` for `ValueSource`
  `AssociationList`
  `getValueSources()`
  Gets the AssociationList of `ValueSources`
  `AssociationList`
  `getValueSources(boolean fGoToServer)`
  Gets the Associationlist of `ValueSources`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `PromptReferences`
  `ValueSource`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setPromptEnabledObject(Root inObject)`
  Sets the `PromptEnabledObjects` list 0th element to be `inObject`.
  `void`
  `setPromptEnabledObjects(AssociationList list)`
  Sets the `PromptEnabledObjects` list to be `list`.
  `void`
  `setPromptEnabledObjects(AssociationList list, int state)`
  Sets the `PromptEnabledObjects` list to be `list`.
  `void`
  `setPromptReferences(AssociationList list)`
  Sets the `PromptReferences` list to be `list`.
  `void`
  `setPromptReferences(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setReferencedPrompts(AssociationList list)`
  Sets the `ReferencedPrompts` list to be `list`.
  `void`
  `setReferencedPrompts(AssociationList inObjects, int state)`
  Sets the entire ReferencedPrompts list to match the passed in AssociationList, sets the state of the ReferencedPrompts
  `void`
  `setValueSource(Transformation inObject)`
  Sets the `ValueSources` list 0th element to be `inObject`.
  `void`
  `setValueSources(AssociationList list)`
  Sets the `ValueSources` list to be `list`.
  `void`
  `setValueSources(AssociationList list, int state)`
  Sets the `ValueSources` list to be `list`.

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ASSOCIATION_PROMPTREFERENCES_NAME

    static final String ASSOCIATION_PROMPTREFERENCES_NAME
    Constant used for the name of the PromptReferences association.

    PromptReferences: The shared prompt(s) that are referenced by this prompt or prompt group.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_VALUESOURCE_NAME

    static final String ASSOCIATION_VALUESOURCE_NAME
    Constant used for the name of the ValueSource association.

    ValueSource: The source of the transformation will point to the table, cube, map, file, or textstore that contains the information for a list of values. The transformation may have source code

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_PROMPTENABLEDOBJECT_NAME

    static final String ASSOCIATION_PROMPTENABLEDOBJECT_NAME
    Constant used for the name of the PromptEnabledObject association.

    PromptEnabledObject: The object that uses this prompt or prompt group.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_REFERENCEDPROMPTS_NAME

    static final String ASSOCIATION_REFERENCEDPROMPTS_NAME
    Constant used for the name of the ReferencedPrompts association.

    ReferencedPrompts: The prompts and prompt groups that are referenced by this shared prompt.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `PromptReferences`
    `ValueSource`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPromptReferences

    AssociationList getPromptReferences() throws RemoteException, MdException
    Gets the AssociationList of `PromptReferences`
    Returns:
      Returns the AssociationList of `PromptReferences` which can be of type:
      AbstractPrompt
      Prompt
      PromptGroup
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getValueSources

    AssociationList getValueSources() throws RemoteException, MdException
    Gets the AssociationList of `ValueSources`
    Returns:
      Returns the AssociationList of `ValueSources` which can be of type:
      Transformation
      ClassifierMap
      Select
      Join
      AbstractJob
      Job
      JFJob
      MiningResult
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getValueSource

    Transformation getValueSource() throws RemoteException, MdException
    Gets the `Transformation` for `ValueSource`
    Returns:
      The `Transformation` ( `null` if not set) of `ValueSource`which can be of type:
      Transformation
      ClassifierMap
      Select
      Join
      AbstractJob
      Job
      JFJob
      MiningResult
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getPromptEnabledObjects

    AssociationList getPromptEnabledObjects() throws RemoteException, MdException
    Gets the Association list of `PromptEnabledObjects`
    Returns:
      The AssociationList of `PromptEnabledObjects` which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getPromptEnabledObject

    Root getPromptEnabledObject() throws RemoteException, MdException
    Gets the `Root` for `PromptEnabledObject`
    Returns:
      The `Root` ( `null` if not set ) of `PromptEnabledObject` which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getReferencedPrompts

    AssociationList getReferencedPrompts() throws RemoteException, MdException
    Gets the Association list of `ReferencedPrompts`
    Returns:
      The AssociationList of `ReferencedPrompts` which can be of type:
      AbstractPrompt
      Prompt
      PromptGroup
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getPromptReferences

    AssociationList getPromptReferences(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `PromptReferences`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `PromptReferences` which can be of type:
      AbstractPrompt
      Prompt
      PromptGroup
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getValueSources

    AssociationList getValueSources(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `ValueSources`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `ValueSources` which can be of type:
      Transformation
      ClassifierMap
      Select
      Join
      AbstractJob
      Job
      JFJob
      MiningResult
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getPromptEnabledObjects

    AssociationList getPromptEnabledObjects(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `PromptEnabledObjects`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `PromptEnabledObjects` which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getReferencedPrompts

    AssociationList getReferencedPrompts(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `ReferencedPrompts`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the `ReferencedPrompts` which can be of type:
      AbstractPrompt
      Prompt
      PromptGroup
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setPromptReferences

    void setPromptReferences(AssociationList list) throws RemoteException
    Sets the `PromptReferences` list to be `list`. Objects of which can be of type:
    AbstractPrompt
    Prompt
    PromptGroup
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPromptReferences

    void setPromptReferences(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setValueSources

    void setValueSources(AssociationList list) throws RemoteException
    Sets the `ValueSources` list to be `list`. Object of which can be of type:
    Transformation
    ClassifierMap
    Select
    Join
    AbstractJob
    Job
    JFJob
    MiningResult
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setValueSources

    void setValueSources(AssociationList list, int state) throws RemoteException
    Sets the `ValueSources` list to be `list`. Object of which can be of type:
    Transformation
    ClassifierMap
    Select
    Join
    AbstractJob
    Job
    JFJob
    MiningResult
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setValueSource

    void setValueSource(Transformation inObject) throws RemoteException
    Sets the `ValueSources` list 0th element to be `inObject`.
    Parameters:
      `inObject` - Transformation
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPromptEnabledObjects

    void setPromptEnabledObjects(AssociationList list) throws RemoteException
    Sets the `PromptEnabledObjects` list to be `list`. Objects of which can be of type:
    All types
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPromptEnabledObjects

    void setPromptEnabledObjects(AssociationList list, int state) throws RemoteException
    Sets the `PromptEnabledObjects` list to be `list`. Objects of which can be of type:
    All types
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPromptEnabledObject

    void setPromptEnabledObject(Root inObject) throws RemoteException
    Sets the `PromptEnabledObjects` list 0th element to be `inObject`.
    Parameters:
      `inObject` - Root
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setReferencedPrompts

    void setReferencedPrompts(AssociationList list) throws RemoteException
    Sets the `ReferencedPrompts` list to be `list`. Objects of which can be of type:
    AbstractPrompt
    Prompt
    PromptGroup
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setReferencedPrompts

    void setReferencedPrompts(AssociationList inObjects, int state) throws RemoteException
    Sets the entire ReferencedPrompts list to match the passed in AssociationList, sets the state of the ReferencedPrompts
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.